# Copyright 2008, Didier Bur
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#----------------------------------------------------------------------------
# Name : Fast texture Writer
# Description : a tool to quickly extract textures from a SU model, to the current directory
# Menu Item : None
# Date : Feb. 12 2008
# Type : for developers only
#----------------------------------------------------------------------------

def fast_tw
# Create virtual face
p1=Geom::Point3d.new(0,0,10000)
p2=Geom::Point3d.new(1,0,10000)
p3=Geom::Point3d.new(1,1,10000)
p4=Geom::Point3d.new(0,1,10000)
face=Sketchup.active_model.entities.add_face [p1,p2,p3,p4]
tw = Sketchup.create_texture_writer
# Iterate through materials, assign to face, load in tw
Sketchup.active_model.materials.each do |mat|
  if mat.texture
    face.material= mat
    tw.load face, true
  end
end
# Output textures
tw.write_all(File.dirname(Sketchup.active_model.path) + "/", false)
# Delete virtual face
edges=face.edges
edges.each { |e| e.erase! if e.valid? }
end
